#include <windows.h>
#include "ddraw.h"

#define TITLE "Erreur"

void DD_Error_Msg(HWND hWnd, HRESULT h)
{
	switch (h)
	{
	case DDERR_ALREADYINITIALIZED :
		MessageBox(hWnd, "Erreur DDERR_ALREADYINITIALIZED", TITLE, MB_OK);	
		break;
	case DDERR_BLTFASTCANTCLIP :
		MessageBox(hWnd, "Erreur DDERR_BLTFASTCANTCLIP", TITLE, MB_OK);	
		break;
	case  DDERR_CANNOTATTACHSURFACE :
		MessageBox(hWnd, "Erreur DDERR_CANNOTATTACHSURFACE ", TITLE, MB_OK);	
		break;
	case  DDERR_CANNOTDETACHSURFACE :
		MessageBox(hWnd, "Erreur DDERR_CANNOTDETACHSURFACE ", TITLE, MB_OK);	
		break;
	case  DDERR_CANTCREATEDC:
		MessageBox(hWnd, "Erreur DDERR_CANTCREATEDC", TITLE, MB_OK);	
		break;
	case  DDERR_CANTDUPLICATE:
		MessageBox(hWnd, "Erreur DDERR_CANTDUPLICATE", TITLE, MB_OK);	
		break;
	case  DDERR_CANTLOCKSURFACE :
		MessageBox(hWnd, "Erreur DDERR_CANTLOCKSURFACE ", TITLE, MB_OK);	
		break;
	case  DDERR_CANTPAGELOCK:
		MessageBox(hWnd, "Erreur DDERR_CANTPAGELOCK", TITLE, MB_OK);	
		break;
	case  DDERR_CANTPAGEUNLOCK :
		MessageBox(hWnd, "Erreur DDERR_CANTPAGEUNLOCK ", TITLE, MB_OK);	
		break;
	case  DDERR_CLIPPERISUSINGHWND:
		MessageBox(hWnd, "Erreur DDERR_CLIPPERISUSINGHWND", TITLE, MB_OK);	
		break;
	case  DDERR_COLORKEYNOTSET:
		MessageBox(hWnd, "Erreur DDERR_COLORKEYNOTSET", TITLE, MB_OK);	
		break;
	case  DDERR_CURRENTLYNOTAVAIL:
		MessageBox(hWnd, "Erreur DDERR_CURRENTLYNOTAVAIL", TITLE, MB_OK);	
		break;
	case  DDERR_DCALREADYCREATED:
		MessageBox(hWnd, "Erreur DDERR_DCALREADYCREATED", TITLE, MB_OK);	
		break;
	case  DDERR_DIRECTDRAWALREADYCREATED:
		MessageBox(hWnd, "Erreur DDERR_DIRECTDRAWALREADYCREATED", TITLE, MB_OK);	
		break;
	case  DDERR_EXCEPTION :
		MessageBox(hWnd, "Erreur DDERR_EXCEPTION ", TITLE, MB_OK);	
		break;
	case  DDERR_EXCLUSIVEMODEALREADYSET:
		MessageBox(hWnd, "Erreur DDERR_EXCLUSIVEMODEALREADYSET", TITLE, MB_OK);	
		break;
	case  DDERR_GENERIC :
		MessageBox(hWnd, "Erreur DDERR_GENERIC ", TITLE, MB_OK);	
		break;
	case  DDERR_HEIGHTALIGN :
		MessageBox(hWnd, "Erreur DDERR_HEIGHTALIGN ", TITLE, MB_OK);	
		break;
	case  DDERR_HWNDALREADYSET :
		MessageBox(hWnd, "Erreur DDERR_HWNDALREADYSET ", TITLE, MB_OK);	
		break;
	case  DDERR_HWNDSUBCLASSED:
		MessageBox(hWnd, "Erreur DDERR_HWNDSUBCLASSED", TITLE, MB_OK);	
		break;
	case DDERR_IMPLICITLYCREATED:
		MessageBox(hWnd, "Erreur DDERR_IMPLICITLYCREATED", TITLE, MB_OK);	
		break;
	case DDERR_INCOMPATIBLEPRIMARY :
		MessageBox(hWnd, "Erreur DDERR_INCOMPATIBLEPRIMARY ", TITLE, MB_OK);	
		break;
	case DDERR_INVALIDCAPS:
		MessageBox(hWnd, "Erreur DDERR_INVALIDCAPS", TITLE, MB_OK);	
		break;
	case DDERR_INVALIDCLIPLIST:
		MessageBox(hWnd, "Erreur DDERR_INVALIDCLIPLIST", TITLE, MB_OK);	
		break;
	case DDERR_INVALIDDIRECTDRAWGUID:
		MessageBox(hWnd, "Erreur DDERR_INVALIDDIRECTDRAWGUID", TITLE, MB_OK);	
		break;
	case DDERR_INVALIDMODE:
		MessageBox(hWnd, "Erreur DDERR_INVALIDMODE", TITLE, MB_OK);	
		break;
	case DDERR_INVALIDOBJECT :
		MessageBox(hWnd, "Erreur DDERR_INVALIDOBJECT ", TITLE, MB_OK);	
		break;
	case DDERR_INVALIDPARAMS :
		MessageBox(hWnd, "Erreur DDERR_INVALIDPARAMS ", TITLE, MB_OK);	
		break;
	case DDERR_INVALIDPIXELFORMAT :
		MessageBox(hWnd, "Erreur DDERR_INVALIDPIXELFORMAT ", TITLE, MB_OK);
		break;
	case DDERR_INVALIDPOSITION:
		MessageBox(hWnd, "Erreur DDERR_INVALIDPOSITION", TITLE, MB_OK);
		break;
	case DDERR_INVALIDRECT :
		MessageBox(hWnd, "Erreur DDERR_INVALIDRECT ", TITLE, MB_OK);	
		break;
	case DDERR_INVALIDSURFACETYPE:
		MessageBox(hWnd, "Erreur DDERR_INVALIDSURFACETYPE", TITLE, MB_OK);	
		break;
	case DDERR_LOCKEDSURFACES :
		MessageBox(hWnd, "Erreur DDERR_LOCKEDSURFACES ", TITLE, MB_OK);	
		break;
	case DDERR_NO3D :
		MessageBox(hWnd, "Erreur DDERR_NO3D ", TITLE, MB_OK);	
		break;
	case DDERR_NOALPHAHW :
		MessageBox(hWnd, "Erreur DDERR_NOALPHAHW ", TITLE, MB_OK);	
		break;
	case DDERR_NOBLTHW :
		MessageBox(hWnd, "Erreur DDERR_NOBLTHW ", TITLE, MB_OK);	
		break;
	case DDERR_NOCLIPLIST:
		MessageBox(hWnd, "Erreur DDERR_NOCLIPLIST", TITLE, MB_OK);	
		break;
	case DDERR_NOCLIPPERATTACHED :
		MessageBox(hWnd, "Erreur DDERR_NOCLIPPERATTACHED ", TITLE, MB_OK);	
		break;
	case DDERR_NOCOLORCONVHW:
		MessageBox(hWnd, "Erreur DDERR_NOCOLORCONVHW", TITLE, MB_OK);	
		break;
	case DDERR_NOCOLORKEY:
		MessageBox(hWnd, "Erreur DDERR_NOCOLORKEY", TITLE, MB_OK);	
		break;
	case DDERR_NOCOLORKEYHW:
		MessageBox(hWnd, "Erreur DDERR_NOCOLORKEYHW", TITLE, MB_OK);	
		break;
	case DDERR_NOCOOPERATIVELEVELSET :
		MessageBox(hWnd, "Erreur DDERR_NOCOOPERATIVELEVELSET ", TITLE, MB_OK);	
		break;
	case DDERR_NODC:
		MessageBox(hWnd, "Erreur DDERR_NODC", TITLE, MB_OK);	
		break;
	case DDERR_NODDROPSHW:
		MessageBox(hWnd, "Erreur DDERR_NODDROPSHW", TITLE, MB_OK);	
		break;
	case DDERR_NODIRECTDRAWHW:
		MessageBox(hWnd, "Erreur DDERR_NODIRECTDRAWHW", TITLE, MB_OK);	
		break;
	case DDERR_NODIRECTDRAWSUPPORT :
		MessageBox(hWnd, "Erreur DDERR_NODIRECTDRAWSUPPORT ", TITLE, MB_OK);	
		break;
	case DDERR_NOEMULATION:
		MessageBox(hWnd, "Erreur DDERR_NOEMULATION", TITLE, MB_OK);	
		break;
	case DDERR_NOEXCLUSIVEMODE:
		MessageBox(hWnd, "Erreur DDERR_NOEXCLUSIVEMODE", TITLE, MB_OK);	
		break;
	case DDERR_NOFLIPHW:
		MessageBox(hWnd, "Erreur DDERR_NOFLIPHW", TITLE, MB_OK);	
		break;
	case DDERR_NOGDI :
		MessageBox(hWnd, "Erreur DDERR_NOGDI ", TITLE, MB_OK);	
		break;
	case DDERR_NOHWND:
		MessageBox(hWnd, "Erreur DDERR_NOHWND", TITLE, MB_OK);	
		break;
	case DDERR_NOMIPMAPHW :
		MessageBox(hWnd, "Erreur DDERR_NOMIPMAPHW ", TITLE, MB_OK);	
		break;
	case DDERR_NOMIRRORHW :
		MessageBox(hWnd, "Erreur DDERR_NOMIRRORHW ", TITLE, MB_OK);	
		break;
	case DDERR_NOOVERLAYDEST :
		MessageBox(hWnd, "Erreur DDERR_NOOVERLAYDEST ", TITLE, MB_OK);	
		break;
	case DDERR_NOOVERLAYHW:
		MessageBox(hWnd, "Erreur DDERR_NOOVERLAYHW", TITLE, MB_OK);	
		break;
	case DDERR_NOPALETTEATTACHED:
		MessageBox(hWnd, "Erreur DDERR_NOPALETTEATTACHED", TITLE, MB_OK);	
		break;
	case DDERR_NOPALETTEHW:
		MessageBox(hWnd, "Erreur DDERR_NOPALETTEHW", TITLE, MB_OK);	
		break;
	case DDERR_NORASTEROPHW:
		MessageBox(hWnd, "Erreur DDERR_NORASTEROPHW", TITLE, MB_OK);	
		break;
	case DDERR_NOROTATIONHW :
		MessageBox(hWnd, "Erreur DDERR_NOROTATIONHW ", TITLE, MB_OK);	
		break;
	case DDERR_NOSTRETCHHW :
		MessageBox(hWnd, "Erreur DDERR_NOSTRETCHHW ", TITLE, MB_OK);	
		break;
	case DDERR_NOT4BITCOLOR :
		MessageBox(hWnd, "Erreur DDERR_NOT4BITCOLOR ", TITLE, MB_OK);	
		break;
	case DDERR_NOT4BITCOLORINDEX :
		MessageBox(hWnd, "Erreur DDERR_NOT4BITCOLORINDEX ", TITLE, MB_OK);	
		break;
	case DDERR_NOT8BITCOLOR :
		MessageBox(hWnd, "Erreur DDERR_NOT8BITCOLOR ", TITLE, MB_OK);	
		break;
	case DDERR_NOTAOVERLAYSURFACE :
		MessageBox(hWnd, "Erreur DDERR_NOTAOVERLAYSURFACE ", TITLE, MB_OK);	
		break;
	case DDERR_NOTEXTUREHW :
		MessageBox(hWnd, "Erreur DDERR_NOTEXTUREHW ", TITLE, MB_OK);	
		break;
	case DDERR_NOTFLIPPABLE:
		MessageBox(hWnd, "Erreur DDERR_NOTFLIPPABLE", TITLE, MB_OK);	
		break;
	case DDERR_NOTFOUND :
		MessageBox(hWnd, "Erreur DDERR_NOTFOUND ", TITLE, MB_OK);	
		break;
	case DDERR_NOTINITIALIZED :
		MessageBox(hWnd, "Erreur DDERR_NOTINITIALIZED ", TITLE, MB_OK);	
		break;
	case DDERR_NOTLOCKED:
		MessageBox(hWnd, "Erreur DDERR_NOTLOCKED", TITLE, MB_OK);	
		break;
	case DDERR_NOTPAGELOCKED:
		MessageBox(hWnd, "Erreur DDERR_NOTPAGELOCKED", TITLE, MB_OK);	
		break;
	case DDERR_NOTPALETTIZED:
		MessageBox(hWnd, "Erreur DDERR_NOTPALETTIZED", TITLE, MB_OK);	
		break;
	case DDERR_NOVSYNCHW :
		MessageBox(hWnd, "Erreur DDERR_NOVSYNCHW ", TITLE, MB_OK);	
		break;
	case DDERR_NOZBUFFERHW:
		MessageBox(hWnd, "Erreur DDERR_NOZBUFFERHW", TITLE, MB_OK);	
		break;
	case DDERR_NOZOVERLAYHW :
		MessageBox(hWnd, "Erreur DDERR_NOZOVERLAYHW ", TITLE, MB_OK);	
		break;
	case DDERR_OUTOFCAPS :
		MessageBox(hWnd, "Erreur DDERR_OUTOFCAPS ", TITLE, MB_OK);	
		break;
	case DDERR_OUTOFMEMORY :
		MessageBox(hWnd, "Erreur DDERR_OUTOFMEMORY ", TITLE, MB_OK);	
		break;
	case DDERR_OUTOFVIDEOMEMORY :
		MessageBox(hWnd, "Erreur DDERR_OUTOFVIDEOMEMORY ", TITLE, MB_OK);	
		break;
	case DDERR_OVERLAYCANTCLIP :
		MessageBox(hWnd, "Erreur DDERR_OVERLAYCANTCLIP ", TITLE, MB_OK);	
		break;
	case DDERR_OVERLAYCOLORKEYONLYONEACTIVE:
		MessageBox(hWnd, "Erreur DDERR_OVERLAYCOLORKEYONLYONEACTIVE", TITLE, MB_OK);	
		break;
	case DDERR_OVERLAYNOTVISIBLE :
		MessageBox(hWnd, "Erreur DDERR_OVERLAYNOTVISIBLE ", TITLE, MB_OK);	
		break;
	case DDERR_PALETTEBUSY:
		MessageBox(hWnd, "Erreur DDERR_PALETTEBUSY", TITLE, MB_OK);	
		break;
	case DDERR_PRIMARYSURFACEALREADYEXISTS:
		MessageBox(hWnd, "Erreur DDERR_PRIMARYSURFACEALREADYEXISTS", TITLE, MB_OK);	
		break;
	case DDERR_REGIONTOOSMALL :
		MessageBox(hWnd, "Erreur DDERR_REGIONTOOSMALL ", TITLE, MB_OK);	
		break;
	case DDERR_SURFACEALREADYATTACHED:
		MessageBox(hWnd, "Erreur DDERR_SURFACEALREADYATTACHED", TITLE, MB_OK);	
		break;
	case DDERR_SURFACEALREADYDEPENDENT:
		MessageBox(hWnd, "Erreur DDERR_SURFACEALREADYDEPENDENT", TITLE, MB_OK);	
		break;
	case DDERR_SURFACEBUSY:
		MessageBox(hWnd, "Erreur DDERR_SURFACEBUSY", TITLE, MB_OK);	
		break;
	case DDERR_SURFACEISOBSCURED:
		MessageBox(hWnd, "Erreur DDERR_SURFACEISOBSCURED", TITLE, MB_OK);	
		break;
	case DDERR_SURFACELOST:
		MessageBox(hWnd, "Erreur DDERR_SURFACELOST", TITLE, MB_OK);	
		break;
	case DDERR_SURFACENOTATTACHED :
		MessageBox(hWnd, "Erreur DDERR_SURFACENOTATTACHED ", TITLE, MB_OK);	
		break;
	case DDERR_TOOBIGHEIGHT:
		MessageBox(hWnd, "Erreur DDERR_TOOBIGHEIGHT", TITLE, MB_OK);	
		break;
	case DDERR_TOOBIGSIZE :
		MessageBox(hWnd, "Erreur DDERR_TOOBIGSIZE ", TITLE, MB_OK);	
		break;
	case DDERR_TOOBIGWIDTH:
		MessageBox(hWnd, "Erreur DDERR_TOOBIGWIDTH", TITLE, MB_OK);	
		break;
	case DDERR_UNSUPPORTED :
		MessageBox(hWnd, "Erreur DDERR_UNSUPPORTED ", TITLE, MB_OK);	
		break;
	case DDERR_UNSUPPORTEDFORMAT :
		MessageBox(hWnd, "Erreur DDERR_UNSUPPORTEDFORMAT ", TITLE, MB_OK);	
		break;
	case DDERR_UNSUPPORTEDMASK :
		MessageBox(hWnd, "Erreur DDERR_UNSUPPORTEDMASK ", TITLE, MB_OK);	
		break;
	case DDERR_UNSUPPORTEDMODE:
		MessageBox(hWnd, "Erreur DDERR_UNSUPPORTEDMODE", TITLE, MB_OK);	
		break;
	case DDERR_VERTICALBLANKINPROGRESS :
		MessageBox(hWnd, "Erreur DDERR_VERTICALBLANKINPROGRESS ", TITLE, MB_OK);	
		break;
	case DDERR_WASSTILLDRAWING :
		MessageBox(hWnd, "Erreur DDERR_WASSTILLDRAWING ", TITLE, MB_OK);	
		break;
	case DDERR_WRONGMODE:
		MessageBox(hWnd, "Erreur DDERR_WRONGMODE", TITLE, MB_OK);	
		break;
	case DDERR_XALIGN:
		MessageBox(hWnd, "Erreur DDERR_XALIGN", TITLE, MB_OK);	
		break;
	case DD_OK : break;
	default :
		MessageBox(hWnd, "Erreur inconnue", TITLE, MB_OK);	
		break;
	}
}