#include "main.h"
#include "ddutil.h"
#include "sprite.h"
#include "map.h"
#include "joueur.h"
#include "bombe.h"
#include "cpt_rebours.h"
#include "reseau.h"
#include "setup.h"

char SpriteBmp[NBJMAX][100] = { "Gfx\\Sprite.bmp",
								"Gfx\\Sprite2.bmp",
								"Gfx\\Sprite3.bmp",
								"Gfx\\Sprite4.bmp",
								"Gfx\\Sprite5.bmp",
								"Gfx\\Sprite6.bmp",
								"Gfx\\Sprite7.bmp",
								"Gfx\\Sprite8.bmp"};

void LoadSprite()
{
	for (int i = 0 ; i < nbj ; i++)
		if (j[i])
			delete j[i];
	CreateJoueur();
	if (cpt_)
		delete cpt_;
	cpt_ = new cpt_r(initime);
	if (lst)
		delete lst;
	lst = new ListeBombe;
}

void LoadFond(LPDIRECTDRAW &lpDD, LPDIRECTDRAWSURFACE &Fond, char *fname)
{
	if (Fond)
	{
		Fond->Release ();
		Fond = NULL;
	}
	Fond = DDLoadBitmap(lpDD, fname, 0, 0);
}

void AffFond(LPDIRECTDRAWSURFACE dest, LPDIRECTDRAWSURFACE Fond)
{
	dest->BltFast(0, 0, Fond, NULL, DDBLTFAST_WAIT);
}
