#include "ddstuff.h"
#include "alphabet.h"
#include "ddutil.h"

void LoadAlphabet ()
{
	if (!lpDDSAlphabet)
	{
		lpDDSAlphabet = DDLoadBitmap(lpDD, "Gfx\\alphabet.bmp", 0, 0);
		DDSetColorKey(lpDDSAlphabet, COLORKEY);		
	}
}

void Affiche (int x, int y, char *s)
{
	if (!lpDDSAlphabet)
		return;

	for (int n = strlen (s), i = 0 ; n ; i++,n--, x+=CHARX)
	{
		RECT rs = {(s[i]-'-')*CHARX,0,(s[i]-'-'+1)*CHARX,CHARY};
		lpDDSBack->BltFast (x,y,lpDDSAlphabet, &rs, DDBLTFAST_SRCCOLORKEY | DDBLTFAST_WAIT);
	}
}
