#ifndef __BOMBE__
#define __BOMBE__

#include <windows.h>
#include "ddraw.h"
#include "Joueur.h"

#define	TMP_BOMBE	2000
#define TMP_FLAMME	 250

#define BOMBEF	"gfx\\bombe.bmp"

struct bombe
{
	int x, y;
	DWORD proprio;
	Joueur *p;
	int lg_flamme;
	int temps;			// en ms
	BOOL explose;
	int delai[NBSPR];
	int numanim;

	bombe *suiv, *prec;
};

typedef bombe *pbombe;

class ListeBombe
{
public:
	ListeBombe();
	~ListeBombe();

	void AddBombe(Joueur *j);
	void AddBombe(bombe *b);
	void Update(int t);
	pbombe DelBombe(pbombe bombe);
	void Aff();

	pbombe liste;
	LPDIRECTDRAWSURFACE	lpDDSBombe[NBSPR];
};

extern ListeBombe *lst;

#endif