#include "main.h"
#include "resource.h"
#include "DD_ERR.h"
#include "Sprite.h"
#include "Map.h"
#include "Keyb.h"
#include "direct.h"
#include "cpt_rebours.h"
#include "setup.h"
#include "reseau.h"
#include "son.h"
#include "swap.h"
#include "update.h"

#define NAME  "BOMBERMAN"
#define TITLE "Bomberman version beta 1.06"

#define DDRELEASE(lp) if (lp) {lp->Release(); lp = NULL;}
#define NDELETE(ptr) if (ptr) {delete ptr; ptr = NULL;}

HWND  mainhwnd = NULL;
HINSTANCE hInst;

int nbC = 16;
int WNT = 0;
int Sound = 0;
bool cheatmode = false;

int mode = INTRO;

BOOL HasFocus = TRUE, FullScreenMode = TRUE;

MapSprite *MapSpr = NULL;

DWORD Carte[NBDALLEX][NBDALLEY];

void ReleaseAllObjects()
{
	Quitter_Reseau ();
    if (!WNT && lpdi) 
    { 
        if (lpdiDevice) 
        { 
             lpdiDevice->Unacquire(); 
             lpdiDevice->Release();
             lpdiDevice = NULL; 
        } 
        lpdi->Release();
        lpdi = NULL; 
    } 
	
    if (lpDD != NULL)
    {
		lpDD->RestoreDisplayMode();
		for (int i = 0; i < nbj; i++)
			NDELETE(j[i]);

		NDELETE(lst);
		NDELETE(cpt_);
		NDELETE(MapSpr)
		for (i = 0 ; i < NBEVENTS ; i++)
			DDRELEASE(lpdsb[i])
		DDRELEASE(lpds)
		DDRELEASE(lpDDSFond)
		DDRELEASE(lpDDSAlphabet)
		DDRELEASE(lpDDSPrimary)
		DDRELEASE(lpDD)
    }
}

long FAR PASCAL WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_DESTROY:
            // Clean up and close the app
            ReleaseAllObjects();
            PostQuitMessage(0);
            return 0L;

        case WM_KEYDOWN:
            // Handle any non-accelerated key commands
            switch (wParam)
            {
                case VK_ESCAPE:
					Swap2End ();
                    return 0L;
				case VK_F1:
					if (j[0] && cheatmode)
						j[0]->nbre_vie=1;
					return 0L;
				case VK_F2:
					if (j[1] && cheatmode)
						j[1]->nbre_vie=1;
					return 0L;
				case VK_F3:
					if (j[2] && cheatmode)
						j[2]->nbre_vie=1;
					return 0L;
				case VK_F4:
					if (j[3] && cheatmode)
						j[3]->nbre_vie=1;
					return 0L;
				case VK_F5:
					if (cpt_ && cheatmode)
						cpt_->cpt+=1000;
					return 0L;
				case VK_F6:
					fps = !fps;
					return 0L;
				case VK_F12:
					cheatmode = !cheatmode;
					return 0L;
				case VK_LEFT:
					if (WNT)
						SETKEY(bufferkeyb,tab_touche[0].gauche);
					return 0L;
				case VK_RIGHT:
					if (WNT)
						SETKEY(bufferkeyb,tab_touche[0].droite);
					return 0L;
				case VK_UP:
					if (WNT)
						SETKEY(bufferkeyb,tab_touche[0].haut);
					return 0L;
				case VK_DOWN:
					if (WNT)
						SETKEY(bufferkeyb,tab_touche[0].bas);
					return 0L;
				case VK_DELETE:
					if (WNT)
						SETKEY(bufferkeyb,tab_touche[0].bombe);
					return 0L;
				case 'D':
					if (WNT)
						SETKEY(bufferkeyb,tab_touche[1].gauche);
					return 0L;
				case 'G':
					if (WNT)
						SETKEY(bufferkeyb,tab_touche[1].droite);
					return 0L;
				case 'R':
					if (WNT)
						SETKEY(bufferkeyb,tab_touche[1].haut);
					return 0L;
				case 'F':
					if (WNT)
						SETKEY(bufferkeyb,tab_touche[1].bas);
					return 0L;
				case 'S':
					if (WNT)
						SETKEY(bufferkeyb,tab_touche[1].bombe);
					return 0L;
				case VK_SPACE:
					if (WNT)
						SETKEY(bufferkeyb,DIK_SPACE);
					return 0L;
            }
            break;
		case WM_KEYUP:
            // Handle any non-accelerated key commands
            switch (wParam)
            {
				case VK_LEFT:
					if (WNT)
						CLRKEY(bufferkeyb,tab_touche[0].gauche);
					return 0L;
				case VK_RIGHT:
					if (WNT)
						CLRKEY(bufferkeyb,tab_touche[0].droite);
					return 0L;
				case VK_UP:
					if (WNT)
						CLRKEY(bufferkeyb,tab_touche[0].haut);
					return 0L;
				case VK_DOWN:
					if (WNT)
						CLRKEY(bufferkeyb,tab_touche[0].bas);
					return 0L;
				case VK_DELETE:
					if (WNT)
						CLRKEY(bufferkeyb,tab_touche[0].bombe);
					return 0L;
				case 'D':
					if (WNT)
						CLRKEY(bufferkeyb,tab_touche[1].gauche);
					return 0L;
				case 'G':
					if (WNT)
						CLRKEY(bufferkeyb,tab_touche[1].droite);
					return 0L;
				case 'R':
					if (WNT)
						CLRKEY(bufferkeyb,tab_touche[1].haut);
					return 0L;
				case 'F':
					if (WNT)
						CLRKEY(bufferkeyb,tab_touche[1].bas);
					return 0L;
				case 'S':
					if (WNT)
						CLRKEY(bufferkeyb,tab_touche[1].bombe);
					return 0L;
				case VK_SPACE:
					if (WNT)
						CLRKEY(bufferkeyb,DIK_SPACE);
					return 0L;
            }
            break;
		case WM_ACTIVATE:
			HasFocus = (LOWORD(wParam) != WA_INACTIVE);
			return 0L;
		case WM_SETCURSOR:
			SetCursor(NULL);
			return TRUE;
	}
    return DefWindowProc(hWnd, message, wParam, lParam);
}


HRESULT InitFail(HWND hWnd, HRESULT hRet, LPCTSTR szError)
{
	DD_Error_Msg(hWnd, hRet);
    ReleaseAllObjects();
    MessageBox(hWnd, szError, TITLE, MB_OK);
    return hRet;
}

BOOL InitApp(HINSTANCE hInstance, HWND &hWnd,int nCmdShow)
{
    WNDCLASS wc;

    // Set up and register window class
    wc.style = 0;
    wc.lpfnWndProc = WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = NULL;
    wc.lpszMenuName = NULL;
    wc.lpszClassName = NAME;
    RegisterClass(&wc);

    // Create a window
    hWnd = CreateWindowEx(0,NAME, TITLE,WS_POPUP, 1, 1, 1, 1, NULL, NULL, hInstance, NULL);
    if (!hWnd)
        return FALSE;

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);
    SetFocus(hWnd);
	ShowWindow (hWnd, 0);

	if (!Setup (hInstance))
		return FALSE;

	if (InitDD(hWnd, FullScreenMode) != DD_OK)
			return FALSE;

	if (!LoadCarte("map\\map1.map"))
		return FALSE;
    return TRUE;
}

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    MSG msg;

	hInst = hInstance;

	_chdir("release");

    if (!InitApp(hInstance, mainhwnd, nCmdShow) )
        return FALSE;

    while (1)
	{
		if (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
		{
			if (!GetMessage(&msg, NULL, 0, 0))
				break;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{
			if (!Update(mainhwnd))
				PostMessage(mainhwnd, WM_CLOSE, 0, 0);
		}
	}
    return msg.wParam;
}
