#ifndef __RESEAU__
#define __RESEAU__

extern int nbj;
extern int isHost;
extern int start;
extern int ready;

#include "dplay.h"
#include "joueur.h"
#include "Bombe.h"

enum {REALSTART, START, READY, MAP, PLAYER, ASSIGNNUM, START2, BOMB, PLAYAGAIN, TIME, SENDREADY, QUERYPLAYAGAIN};

void SendMap();
void ReceiveMap (void *line);
void SendPlayerNum ();
void ReceivePlayerNum (void *tab);
void SendAction (Joueur *j_, int dead, int killedby);
void ReceiveAction (void *player);
void SendBombe (bombe *);
void SendTime (int t);
void SendQueryPlayAgain();
void ReceiveTime (void *p);
void ReceiveBombe (void *b);
BOOL CreatePlayers ();

int Init_Reseau (HWND hWnd);
void Quitter_Reseau ();

void Ready();
void Start();
void StartPlay();
void PlayAgain ();
void SendReady();

extern LPDIRECTPLAY3       lpDP;
extern DPID dpPlayerID[NBJMAXLocal];
extern DPID IDPlayer[NBJMAX];
extern char	PlayerName[NBJMAX][LGNAME];

void ChatterAddPlayer( LPSTR szPlayerName, DPID pidID, HWND hWnd );
void ChatterDeletePlayer( LPSTR szPlayerName, DPID pidID, HWND hWnd );

#endif