#ifndef __JOUEUR__
#define __JOUEUR__

#include "main.h"
#include "ddstuff.h"

#define NBJMAX				8
#define NBJMAXLocal			4

#define LGNAME				15

struct touche {
	int gauche, droite, haut, bas, bombe;
};

extern touche tab_touche[NBJMAXLocal];
extern touche nettab_touche[NBJMAX-1];
extern char playername[NBJMAXLocal][LGNAME];
extern bool isIA[NBJMAXLocal];

#define IMMOBILE		0
#define GAUCHE			1
#define DROITE			2
#define HAUT			3
#define BAS				4
#define POSEBOMBE		5

#define TEMPS_RESTANT	0
#define TEMPS_SPR		1

#define SPEEDMIN		32
#define SPEEDMAX		128
#define SPEEDSTEP		8

typedef bool bStopFind(char bombe[NBDALLEX][NBDALLEY], int i, int j, void *p);

class Joueur
{
public:
	bool HasChanged;
	bool Change;
	Joueur(char *filename, int dx, int dy,int g, int d, int h, int b, int bmb, int isL, int isH, char *name);
	~Joueur();

	
	void Update(int t);
	void Aff();
	void IA (DWORD t);
	Joueur *FindClosest ();
	char FindDir (char bombe[NBDALLEX][NBDALLEY], DWORD t, bStopFind *f, void *p, bool FindClosest, int, int);
	char FindSafeDir (char bombe[NBDALLEX][NBDALLEY], DWORD t);
	char Attack (Joueur *c, char bombe[NBDALLEX][NBDALLEY], DWORD t);
	void CheckBombe (char bombe[NBDALLEX][NBDALLEY], DWORD t);

	int x,y;
	int couleur;
	int lg_flamme;
	int nbre_vie;
	int nb_bombe, nb_bombe_posee,nb_bombe_jeu;
	int vitesse;		// 256me de pixel/ms
	int tab[8];		// pour les bonus et les malus
	int score;
	char nom[LGNAME];

	int gauche, droite, haut, bas, bombe;
	int lastbmb,lastx,lasty;

	LPDIRECTDRAWSURFACE		lpDDSSprite[NBANIM][NBSPR];
	int delai[2][NBANIM][NBSPR];
	int dir, num_anim;

	static int num;
	int n;
	int isLocal;
	int isHumain;
	char *buff;
};

extern Joueur *j[NBJMAX];

void CreateJoueur ();

#endif