#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "setup.h"
#include "resource.h"
#include "reseau.h"
#include "joueur.h"

#define TIMER_ID	1
#define TIMER_RATE	200
int		initime = 120000;

int reseau_enabled = 0;
int NBJLocal = 1;
bool	AcceptingPlayers = false;

LRESULT CALLBACK DlgProcSetupJ( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch( message )
	{
	case WM_INITDIALOG:
		SendDlgItemMessage (hWnd, IDC_NOM1, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)playername[0]);
		SendDlgItemMessage (hWnd, IDC_NOM2, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)playername[1]);
		SendDlgItemMessage (hWnd, IDC_NOM3, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)playername[2]);
		SendDlgItemMessage (hWnd, IDC_NOM4, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)playername[3]);
		SendDlgItemMessage (hWnd, IDC_IA1, BM_SETCHECK, (WPARAM)(isIA[0] ? BST_CHECKED : BST_UNCHECKED), 0);
		SendDlgItemMessage (hWnd, IDC_IA2, BM_SETCHECK, (WPARAM)(isIA[1] ? BST_CHECKED : BST_UNCHECKED), 0);
		SendDlgItemMessage (hWnd, IDC_IA3, BM_SETCHECK, (WPARAM)(isIA[2] ? BST_CHECKED : BST_UNCHECKED), 0);
		SendDlgItemMessage (hWnd, IDC_IA4, BM_SETCHECK, (WPARAM)(isIA[3] ? BST_CHECKED : BST_UNCHECKED), 0);
		break;
    case WM_COMMAND:            
        switch( LOWORD( wParam ) )
        {
		case IDC_IA1:
			isIA[0] = ( SendDlgItemMessage( hWnd, IDC_IA1, BM_GETCHECK, 0, 0 ) == BST_CHECKED );
			break;
		case IDC_IA2:
			isIA[1] = ( SendDlgItemMessage( hWnd, IDC_IA2, BM_GETCHECK, 0, 0 ) == BST_CHECKED );
			break;
		case IDC_IA3:
			isIA[2] = ( SendDlgItemMessage( hWnd, IDC_IA3, BM_GETCHECK, 0, 0 ) == BST_CHECKED );
			break;
		case IDC_IA4:
			isIA[3] = ( SendDlgItemMessage( hWnd, IDC_IA4, BM_GETCHECK, 0, 0 ) == BST_CHECKED );
			break;
        case IDOK:
			SendDlgItemMessage (hWnd, IDC_NOM1, WM_GETTEXT, (WPARAM)LGNAME, (LPARAM)(LPCTSTR)playername[0]);
			SendDlgItemMessage (hWnd, IDC_NOM2, WM_GETTEXT, (WPARAM)LGNAME, (LPARAM)(LPCTSTR)playername[1]);
			SendDlgItemMessage (hWnd, IDC_NOM3, WM_GETTEXT, (WPARAM)LGNAME, (LPARAM)(LPCTSTR)playername[2]);
			SendDlgItemMessage (hWnd, IDC_NOM4, WM_GETTEXT, (WPARAM)LGNAME, (LPARAM)(LPCTSTR)playername[3]);
			EndDialog (hWnd, TRUE);
			break;
        }
        break;
	}
    return FALSE; 
}

LRESULT CALLBACK DlgProcSetup( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch( message )
    {
		case WM_INITDIALOG:
			{
				start = REALSTART - 1;
				SendDlgItemMessage (hWnd, IDC_NBJOUEUR, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)"2");
				SendDlgItemMessage (hWnd, IDC_NBJOUEUR2, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)"1");
				SCROLLINFO i;
				ZeroMemory (&i, sizeof (SCROLLINFO));
				i.cbSize = sizeof (SCROLLINFO);
				i.fMask = SIF_RANGE | SIF_POS ;
				SetScrollInfo (GetDlgItem(hWnd,IDC_CHGNBJ), SB_CTL, &i, TRUE);
				i.nMin = 1;i.nMax = NBJMAXLocal; i.nPos = NBJLocal;
				SetScrollInfo (GetDlgItem(hWnd,IDC_CHGNBJ2), SB_CTL, &i, TRUE);
				SendDlgItemMessage (hWnd, IDC_TIMEEDIT, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)"Duree 2:00");
				SendDlgItemMessage (hWnd, IDC_TIME, TBM_SETRANGE, (WPARAM) (BOOL) TRUE, (LPARAM)(LPCTSTR)MAKELONG(30, 300));
				SendDlgItemMessage (hWnd, IDC_TIME, TBM_SETPOS, (WPARAM) (BOOL) TRUE, (LPARAM)120);
			}
			break;
		case WM_CLOSE:
			EndDialog (hWnd, FALSE);
			break;
		case WM_VSCROLL:
			if ((int) LOWORD(wParam) == SB_LINEDOWN || (int) LOWORD(wParam) == SB_LINEUP )
			{
				char s[20];
				SCROLLINFO i;
				ZeroMemory (&i, sizeof (SCROLLINFO));
				i.cbSize = sizeof (SCROLLINFO);
				i.fMask = SIF_POS | SIF_RANGE;
				if (((HWND) lParam) == GetDlgItem(hWnd,IDC_CHGNBJ))
				{
					GetScrollInfo (GetDlgItem(hWnd,IDC_CHGNBJ), SB_CTL, &i);
					if ((i.nPos < i.nMax) && (((int) LOWORD(wParam)) == SB_LINEUP ))
						i.nPos++;
					if ((i.nPos > i.nMin) && (((int) LOWORD(wParam)) == SB_LINEDOWN ))
						i.nPos--;
					itoa (i.nPos, s, 10);
					SetScrollInfo (GetDlgItem(hWnd, IDC_CHGNBJ), SB_CTL, &i, TRUE);
					SendDlgItemMessage (hWnd, IDC_NBJOUEUR, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)s);
				}
				else
				{
					GetScrollInfo (GetDlgItem(hWnd,IDC_CHGNBJ2), SB_CTL, &i);
					if ((i.nPos > i.nMin) && (((int) LOWORD(wParam)) == SB_LINEDOWN ))
						i.nPos--;
					if ((i.nPos < i.nMax) && (((int) LOWORD(wParam)) == SB_LINEUP ))
						i.nPos++;
					itoa (i.nPos, s, 10);
					NBJLocal = i.nPos;
					SetScrollInfo (GetDlgItem(hWnd, IDC_CHGNBJ2), SB_CTL, &i, TRUE);
					SendDlgItemMessage (hWnd, IDC_NBJOUEUR2, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)s);
				}
				return TRUE;
			}
			break;
		case WM_HSCROLL:
			{
				initime = SendDlgItemMessage (hWnd, IDC_TIME, TBM_GETPOS, 0, 0)*1000;
				char t[15];
				sprintf (t, "Duree %d:%.2d",initime/60000,(initime/1000)%60);
				SendDlgItemMessage (hWnd, IDC_TIMEEDIT, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)t);
			}
			break;
        case WM_COMMAND:            
            switch( LOWORD( wParam ) )
            {
                case IDC_ENABLERESEAU:
				    if ( SendDlgItemMessage( hWnd, IDC_ENABLERESEAU, BM_GETCHECK, 0, 0 ) == BST_CHECKED )
					{
						EnableWindow ( GetDlgItem( hWnd,IDC_STATICRES ), TRUE );
						EnableWindow ( GetDlgItem( hWnd,IDC_RESEAU ), TRUE );
						EnableWindow ( GetDlgItem( hWnd,IDC_STATICNB ), TRUE );
						EnableWindow ( GetDlgItem( hWnd,IDC_NBJOUEUR ), TRUE );
						EnableWindow ( GetDlgItem( hWnd,IDC_CHGNBJ ), TRUE );
						return TRUE;
					}
					else
					{
						EnableWindow ( GetDlgItem( hWnd,IDC_STATICRES ), FALSE );
						EnableWindow ( GetDlgItem( hWnd,IDC_RESEAU ), FALSE );
						EnableWindow ( GetDlgItem( hWnd,IDC_STATICNB ), FALSE );
						EnableWindow ( GetDlgItem( hWnd,IDC_NBJOUEUR ), FALSE );
						EnableWindow ( GetDlgItem( hWnd,IDC_CHGNBJ ), FALSE );
						return TRUE;
					}
					break;
                case IDC_8BITS:
					nbC = ( SendDlgItemMessage( hWnd, IDC_8BITS, BM_GETCHECK, 0, 0 ) == BST_CHECKED ) ? 8 : 16;
					return TRUE;
					break;
				case IDC_RESEAU:
					reseau_enabled = Init_Reseau (hWnd);
					if (!reseau_enabled)
					{
						SendDlgItemMessage( hWnd, IDC_ENABLERESEAU, BM_SETCHECK, BST_UNCHECKED, 0 );
					}
					else
					{
						start = REALSTART;
						EndDialog (hWnd, TRUE);
					}
					return TRUE;
					break;
				case IDC_START :
					start = REALSTART;
					EndDialog (hWnd, TRUE);
					return TRUE;
				case IDC_SETUPJ:
					DialogBox(hInst, MAKEINTRESOURCE(IDD_PLAYERCONFIG), NULL, (DLGPROC)DlgProcSetupJ );
					return TRUE;
					break;
            }
            break;
    }
    return FALSE;
}

LRESULT CALLBACK DlgProcWait( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch( message )
    {
		case WM_INITDIALOG:
			SetTimer (hWnd, TIMER_ID, TIMER_RATE, NULL);
			return TRUE;
		case WM_COMMAND:            
            switch( LOWORD( wParam ) )
            {
                case IDC_START:
					EndDialog (hWnd, TRUE);
            }
            return 0L;
		case WM_TIMER:
			{
				SendDlgItemMessage (hWnd, IDC_LISTJOIN, LB_RESETCONTENT, 0, 0);
				for (int i = 0 ; i < nbj ; i++)
					SendDlgItemMessage (hWnd, IDC_LISTJOIN, LB_ADDSTRING, 0, (LPARAM) (LPCTSTR) PlayerName[i]);
			}
			return 0L;
		case WM_DESTROY:
			KillTimer (hWnd, TIMER_ID);
			return 0L;
		case WM_CLOSE :
			EndDialog(hWnd, FALSE);
			return 0L;
    }
    return FALSE; 
}

LRESULT CALLBACK DlgProcWait2( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch( message )
    {
		case WM_INITDIALOG:
			SetTimer (hWnd, TIMER_ID, TIMER_RATE, NULL);
		break;
		case WM_COMMAND:            
            switch( LOWORD( wParam ) )
            {
                case IDC_CANCELWAIT:
					EndDialog (hWnd, FALSE);
					return TRUE;
            }
            break;
		case WM_TIMER:
			if (start == START)
				EndDialog (hWnd, TRUE);
			break;
		case WM_DESTROY:
			KillTimer (hWnd, TIMER_ID);
			break;

    }
    return FALSE; 
}

BOOL Setup (HINSTANCE hInst)
{
	DialogBox(hInst, MAKEINTRESOURCE(IDD_SETUPBOMB), NULL, (DLGPROC)DlgProcSetup );
	if (start != REALSTART)
		return FALSE;
	if (reseau_enabled)
	{
		if (!CreatePlayers ())
			return FALSE;
		if (isHost)
		{
			AcceptingPlayers = true;
			reseau_enabled = DialogBox(hInst, MAKEINTRESOURCE(IDD_WAIT), NULL, (DLGPROC)DlgProcWait );
			AcceptingPlayers = false;
			if (reseau_enabled)
				Start ();
		}
		else
		{
			reseau_enabled = DialogBox(hInst, MAKEINTRESOURCE(IDD_WAIT2), NULL, (DLGPROC)DlgProcWait2 );
		}
	}
	else
		nbj = NBJLocal;
	return TRUE;
}
